void
nextstrongprime(mpz_t mpzPrime, mpz_t const mpzNumber)
{
    mpz_t mpztemp;

    mpz_set(mpzPrime, mpzNumber);
    if ((mpz_get_ui(mpzPrime) % 2) == 0) {
        mpz_add_ui(mpzPrime, mpzPrime, 1);
        if (mpz_probab_prime_p(mpzPrime, 25) == 1)
            return;
    }

    mpz_init(mpztemp);
    do {
        mpz_add_ui(mpzPrime, mpzPrime, 2);
        while (mpz_probab_prime_p(mpzPrime, 25) != 1)
            mpz_add_ui(mpzPrime, mpzPrime, 2);
        mpz_sub_ui(mpztemp, mpzPrime, 1);
        mpz_tdiv_q_2exp(mpztemp, mpztemp, 1);
    }
    while (mpz_probab_prime_p(mpztemp, 25) != 1);
    mpz_clear(mpztemp);

    return;
}
