/* ElGamal using GMP

   fktn.h

   Copyright (C) 1999/2000 Christian Koch
   ckoch@et.htwk-leipzig.de

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; see the file COPYING.  If not, write to the Free Software
Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */



void
genkeypair(PubKey *, SecKey *, int const);

mpz_t *
encrypt(mpz_t * const, PubKey const, int const);

mpz_t *
decrypt(mpz_t * const, SecKey const, int const);

void
nextstrongprime(mpz_t, mpz_t const);

mpz_t *
str2arr(int * const, unsigned char const *, int const);

unsigned char *
arr2str(int const, mpz_t * const, int const);
